'' =================================================================================================
''
''   File....... jm_4motors_demo.spin
''   Purpose.... 
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''               Copyright (c) 2011 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.com
''   Started.... 
''   Updated.... 20 AUG 2011
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' _xinfreq = 6_250_000                                          ' use 6.25MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1 = 31
  TX1 = 30
  SDA = 29
  SCL = 28


con 

  #(-1), IS_ON, IS_OFF
  

con

   #1, HOME, GOTOXY, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR       ' PST formmatting control
  #14, GOTOX, GOTOY, CLS


con

  M1_PWM = 0
  M1_DIR = 1
  M1_EN  = 2

  M2_PWM = 3
  M2_DIR = 4
  M2_EN  = 5

  M3_PWM = 6
  M3_DIR = 7
  M3_EN  = 8

  M4_PWM = 9
  M4_DIR = 10
  M4_EN  = 11
  

obj

  motors12 : "jm_dualmotor_ez"
  motors34 : "jm_dualmotor_ez"
 

var


pub main | speed

  motors12.start(M1_PWM, M1_DIR, M2_PWM, M2_DIR, 2_500)         ' motors 1 & 2 @ 2.5kHz
  motors34.start(M3_PWM, M3_DIR, M4_PWM, M4_DIR, 2_500)         ' motors 3 & 4 @ 2.5kHz 

  ' set enables

  high(M1_EN)
  high(M2_EN)
  high(M3_EN)
  high(M4_EN)

  repeat
    repeat speed from 0 to 100
      motors12.setspeed(0,  speed)                              ' M1 forward
      motors12.setspeed(1, -speed)                              ' M2 reverse
      motors34.setspeed(0,  speed)                              ' M3 forward
      motors34.setspeed(1, -speed)                              ' M4 reverse
      pause(50)                                                  
    repeat speed from 100 to 0                                   
      motors12.setspeed(0,  speed)                              ' M1 forward
      motors12.setspeed(1, -speed)                              ' M2 reverse
      motors34.setspeed(0,  speed)                              ' M3 forward
      motors34.setspeed(1, -speed)                              ' M4 reverse
      pause(50)
      

pub pause(ms) | t

'' Delay program ms milliseconds

  if (ms > 0)                                                   ' if valid delay
    t := cnt - 1760                                             '  sync (remove call overhead)
    repeat ms                                                   '  run 1ms loops
      waitcnt(t += MS_001)   


pub high(pin)

'' Makes pin output and high

  outa[pin] := 1
  dira[pin] := 1


pub low(pin)

'' Makes pin output and low

  outa[pin] := 0
  dira[pin] := 1


pub toggle(pin)

'' Toggles pin state

  !outa[pin]
  dira[pin] := 1


pub input(pin)

'' Makes pin input and returns current state

  dira[pin] := 0

  return ina[pin]
  
 
dat

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}